package io.gitlab.jfronny.inceptum.gtk.callback;

import io.github.jwharm.javagi.Interop;
import org.jetbrains.annotations.ApiStatus;

import java.lang.foreign.*;
import java.lang.invoke.MethodHandle;

public interface GetNItemsCallback {
    int upcall(MemoryAddress inst);

    @ApiStatus.Internal
    FunctionDescriptor DESCRIPTOR = FunctionDescriptor.of(Interop.valueLayout.C_INT, Interop.valueLayout.ADDRESS);
    @ApiStatus.Internal
    MethodHandle HANDLE = Interop.getHandle(GetNItemsCallback.class, DESCRIPTOR);

    default MemoryAddress toCallback() {
        return Linker.nativeLinker().upcallStub(HANDLE.bindTo(this), DESCRIPTOR, Interop.getScope()).address();
    }
}
