package io.gitlab.jfronny.inceptum.gtk.callback;

import io.github.jwharm.javagi.Interop;
import org.jetbrains.annotations.ApiStatus;

import java.lang.foreign.*;
import java.lang.invoke.MethodHandle;

public interface DisposeCallback {
    void upcall(MemoryAddress pointer);

    @ApiStatus.Internal
    FunctionDescriptor DESCRIPTOR = FunctionDescriptor.ofVoid(Interop.valueLayout.ADDRESS);
    @ApiStatus.Internal
    MethodHandle HANDLE = Interop.getHandle(DisposeCallback.class, DESCRIPTOR);

    default MemoryAddress toCallback() {
        return Linker.nativeLinker().upcallStub(HANDLE.bindTo(this), DESCRIPTOR, Interop.getScope()).address();
    }
}
